//Evilflower Zone Lua file

local wtfefblind = nil
local wtfefmpboss = false
local wtfefboss = nil

addHook("NetVars",function(net)
	wtfefblind = net(wtfefblind)
	wtfefmpboss = net(wtfefmpboss)
	wtfefboss = net(wtfefboss)
end)

addHook("MapLoad",function(mapnum)
	wtfefblind = nil
	wtfefmpboss = false
	wtfefboss = nil
	if G_BuildMapTitle(mapnum) == "Evilflower Zone" then
		for sec in sectors.iterate do
			if sec.lightlevel > 144 then
				sec.lightlevel = 144
			end
		end
	end
end)

addHook("PreThinkFrame",function()
	if G_BuildMapTitle(mapnum) == "Evilflower Zone" then
		if wtfefblind then
			for p in players.iterate do
				p.cmd.buttons = $1 & ~(BT_SPIN|BT_JUMP|BT_CUSTOM1|BT_CUSTOM2|BT_CUSTOM3)
				p.cmd.forwardmove = 0
				p.cmd.sidemove = 0
			end
			wtfefblind = $1 - 1
		elseif wtfefblind == 0 then
			wtfefblind = nil
			for sec in sectors.iterate do
				sec.lightlevel = $1 + 208
			end
			wtfefboss = P_SpawnMobj(10240*FRACUNIT,5568*FRACUNIT,1312*FRACUNIT,MT_EGGMOBILE)
			if wtfefboss then
				wtfefboss.flags2 = $1 | MF2_BOSSNOTRAP
			end
			for p in players.iterate do
				p.realmo.angle = ANGLE_90
			end
			
		elseif wtfefmpboss then
			for p in players.iterate do
				if p.mo and p.mo.x < 8192*FRACUNIT then
					P_TeleportMove(p.mo,10048*FRACUNIT,1024*FRACUNIT,1376*FRACUNIT)
				end
			end
		end
		if wtfefboss and wtfefboss.valid then
			if wtfefboss.target then
				local dist = R_PointToDist2(wtfefboss.x,wtfefboss.y,wtfefboss.target.x,wtfefboss.target.y)
				if dist > 1024*FRACUNIT and wtfefboss.state == S_EGGMOBILE_STND then
					A_Boss1Chase(wtfefboss)
					A_Boss1Chase(wtfefboss)
				end
				if dist > 1536*FRACUNIT and wtfefboss.state != S_EGGMOBILE_STND and not (wtfefboss.flags2 & MF2_FRET) then
					P_SetMobjStateNF(wtfefboss,S_EGGMOBILE_STND)
				end
			elseif wtfefboss.health > 0 then
				P_SupermanLook4Players(wtfefboss)
			end
			if wtfefboss.health > 0 then
				S_ChangeMusic("VSALT",true)
			end
		end
	end
end)

addHook("LinedefExecute",function(line,mobj,sector)
	if wtfefblind then return end
	wtfefblind = TICRATE*2
	if multiplayer then wtfefmpboss = true end
	local specsec = nil
	local raisesec = nil
	local playermo = nil
	for sec in sectors.iterate do
		sec.lightlevel = $1 - 144
		if string.sub(sec.floorpic,1,6) == "CEZFLR" then
			sec.floorpic = "MMFLRA"
		end
		if string.sub(sec.ceilingpic,1,6) == "CEZFLR" then
			sec.ceilingpic = "MMFLRA"
		end
		if sec.special == 3 and sec.tag == 69 then
			specsec = sec
		elseif sec.tag == 71 then
			sec.floorheight = 1312*FRACUNIT
		end
	end
	if specsec then
		specsec.ceilingheight = 964*FRACUNIT
	end
	for p in players.iterate do
		P_TeleportMove(p.realmo,10048*FRACUNIT,1024*FRACUNIT,1376*FRACUNIT)
		P_InstaThrust(p.realmo,p.realmo.angle,0)
		if not playermo then
			playermo = p.realmo --For blockmap search only
		end
	end
	for line in lines.iterate do
		if line.backside then
			if line.backside.toptexture == 3127 or line.backside.toptexture == 3128 then
				line.backside.toptexture = 3337
			end
			if line.backside.bottomtexture == 3127 or line.backside.bottomtexture == 3128 then
				line.backside.bottomtexture = 3337
			end
		end
		if line.frontside.toptexture == 3127 or line.frontside.toptexture == 3128 then
			line.frontside.toptexture = 3337
		end
		if line.frontside.midtexture == 3127 then line.frontside.midtexture = 3337 end
		if line.frontside.bottomtexture == 3127 or line.frontside.bottomtexture == 3128 then
			line.frontside.bottomtexture = 3337
		end
	end
	S_StopMusic()
	searchBlockmap("objects",function(refmobj,foundmobj)
		if foundmobj.type == MT_SIGN then 
			foundmobj.state = S_NULL
			return true
		end
	end,playermo)
end,"WTFEFBOS")